<ui:composition xmlns:s="http://jboss.org/schema/seam/taglib" xmlns:rich="http://richfaces.org/rich"
                xmlns:h="http://java.sun.com/jsf/html" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:gdk="http://www.ihe.net/gazellecdk" xmlns:f="http://java.sun.com/jsf/core"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:a4j="http://richfaces.org/a4j"
                xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">
    <ui:define name="body">
        <h1>#{messages['net.ihe.gazelle.transformation.ObjectTypes']}</h1>
        <h:form id="globalForm">
            <p>
                <h:commandButton id="createNewObjectTypeButton" styleClass="gzl-btn-green"
                                   value="#{messages['net.ihe.gazelle.transformation.NewObjectType']}"
                                   action="/objecttype/create.seam"
                                   rendered="#{s:hasRole('admin_role')}"/>
            </p>

            <rich:dataTable id="objectTypeListTable"
                            value="#{objectTypeManagerBean.getAllObjectTypes()}" var="currentObjectType"
                            rows="#{dataScrollerMemory.numberOfResultsPerPage}">
                <g:column id="KeywordColumn" sortBy="#{'keyword'}" sortOrder="ascending" filterBy="#{'keyword'}">
                    <ui:define name="header">#{messages['net.ihe.gazelle.transformation.Keyword']}
                    </ui:define>
                    <h:outputText value="#{currentObjectType.keyword}"/>
                </g:column>
                <g:column id="LabelColumn" sortBy="#{'name'}" sortOrder="ascending" filterBy="#{'name'}">
                    <ui:define name="header">#{messages['net.ihe.gazelle.transformation.Name']}</ui:define>
                    <h:outputText value="#{currentObjectType.name}"/>
                </g:column>
                <g:column id="DescriptionColumn">
                    <ui:define name="header">
                        #{messages['net.ihe.gazelle.transformation.Description']}
                    </ui:define>
                    <h:outputText value="#{currentObjectType.description}"/>
                </g:column>
                <g:column id="actionColumn" rendered="#{s:hasRole('admin_role')}">
                    <ui:define name="header">#{messages['net.ihe.gazelle.transformation.Action']}
                    </ui:define>
                    <div class="gzl-never-wrap">
                        <a4j:commandLink
                                action="#{objectTypeManagerBean.editObjectType(currentObjectType)}"
                                title="#{messages['net.ihe.gazelle.transformation.Edit']}"
                                execute="@this">
                            <span class="gzl-icon-pencil"></span>
                        </a4j:commandLink>
                        <a4j:commandLink
                                rendered="#{objectTypeManagerBean.isObjectTypeDeletable(currentObjectType)}"
                                title="#{messages['net.ihe.gazelle.transformation.Delete']}"
                                render="deleteTextDiv"
                                oncomplete="jq162('#deleteObjectTypePopup').modal('show');"
                                action="#{objectTypeManagerBean.setSelectedObjectType(currentObjectType)}">
                            <span class="gzl-icon-trash-o"></span>
                        </a4j:commandLink>
                        <s:span title="This type is used by one or more DFDL Schema, you can not delete it."
                                rendered="#{not objectTypeManagerBean.isObjectTypeDeletable(currentObjectType)}" class="fa fa-trash-o"></s:span>
                    </div>
                </g:column>
                <f:facet name="footer">
                    <ui:include src="/util/datatableFooter.xhtml">
                        <ui:param name="dataScrollerId" value="ds"/>
                        <ui:param name="dataTableId" value="objectTypeListTable"/>
                    </ui:include>
                </f:facet>
            </rich:dataTable>

            <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                <ui:param name="popup_id" value="deleteObjectTypePopup"/>
                <ui:param name="styleClass" value="modal-sm"/>
                <ui:param name="headerStyleClass" value="gzl-text-red"/>
                <ui:define name="popup_title">
                    <span class="fa fa-exclamation-triangle"></span>
                    #{messages['net.ihe.gazelle.transformation.DeleteObjectType']}
                </ui:define>
                <ui:param name="bodyStyleClass" value="bg-warning"/>
                <s:div id="deleteTextDiv">
                    <p>
                        <h:outputText
                                value="#{messages['net.ihe.gazelle.transformation.YouAreAboutToDeleteTheObjectType']} '#{objectTypeManagerBean.selectedObjectType.keyword}'"/>
                    </p>
                    <p>
                        <h:outputText value="#{messages['net.ihe.gazelle.transformation.ThisCannotBeUndone']}"/>
                    </p>
                </s:div>
                <ui:define name="popup_footer">
                    <a4j:commandButton value="#{messages['net.ihe.gazelle.transformation.Delete']}"
                                       title="#{messages['net.ihe.gazelle.transformation.Delete']}"
                                       action="#{objectTypeManagerBean.deleteSelectedObjectType()}"
                                       oncomplete="jq162('#deleteObjectTypePopup').modal('hide');"
                                       render="objectTypeListTable"
                                       styleClass="gzl-btn-red"/>
                    <a4j:commandButton value="#{messages['net.ihe.gazelle.transformation.Cancel']}"
                                       styleClass="gzl-btn"
                                       oncomplete="jq162('#deleteObjectTypePopup').modal('hide');"/>
                </ui:define>
            </ui:decorate>
        </h:form>
    </ui:define>
</ui:composition>
